"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var react_redux_1 = require("react-redux");
var redux_1 = require("redux");
var redux_thunk_1 = require("redux-thunk");
var BindReact = (function (_super) {
    __extends(BindReact, _super);
    function BindReact() {
        return _super.apply(this, arguments) || this;
    }
    BindReact.prototype.renderChildren = function (props) {
        return React.Children.map(props.children, function (child) {
            return React.cloneElement(child, __assign({}, props, props.reducers));
        });
    };
    BindReact.prototype.show = function (dispatch, Dev) {
        var Module = this.props.module;
        return (React.createElement("div", null,
            React.createElement(Module, { dispatch: dispatch }),
            Dev ? React.createElement(Dev, null) : '',
            this.renderChildren(this.props)));
    };
    BindReact.prototype.render = function () {
        var _a = this.props, reducers = _a.reducers, _b = _a.middleware, middleware = _b === void 0 ? [] : _b, devTools = _a.devTools;
        var createStoreWithMiddleware;
        // return a function contain compatible API
        var middlewareList = [
            redux_thunk_1["default"]
        ].concat(middleware);
        if (devTools) {
            createStoreWithMiddleware = redux_1.compose(
            // add middleware ahead
            redux_1.applyMiddleware.apply(void 0, middlewareList), 
            // start dev-tools
            devTools.instrument());
        }
        else {
            createStoreWithMiddleware = (redux_1.applyMiddleware.apply(void 0, middlewareList));
        }
        // just use like as createStore()
        var app = redux_1.combineReducers(__assign({}, reducers));
        var store = createStoreWithMiddleware(redux_1.createStore)(app);
        // add dispatch attribute to window
        window['dispatch'] = this.dispatch = store.dispatch;
        return (React.createElement(react_redux_1.Provider, { store: store }, this.show(this.dispatch, devTools)));
    };
    return BindReact;
}(React.Component));
exports.__esModule = true;
exports["default"] = BindReact;
//# sourceMappingURL=BindReact.js.map